import { NButton } from 'naive-ui';
import {
  defineComponent,
  nextTick,
  onMounted,
  reactive,
  ref,
  watch
} from 'vue';
import styles from './index.module.less';
import { getImage } from './images';
import {px2vw,px2vwH} from '@/utils/index'
export default defineComponent({
  name: 'lessons-guide',
  emits: ['close'],
  setup(props, { emit }) {
    const data = reactive({
      box: {
        height:'0px',
      } as any,
      show: false,
      /**
       *
            width:  px2vw(840),
            height:  px2vw(295)
       */
      steps: [
        {
          ele: '',
          eleRect: {} as DOMRect,
          img: getImage('lessons1.png'),
          handStyle: {
            top: '0.91rem'
          },
          imgStyle: {
            left: '-4.4em',
            width:  px2vw(420),
            height:  px2vw(228)
          },
          btnsStyle: {
            bottom:'30px',
            left:  px2vw(90),
          },
          eleRectPadding:{
            left:7,
            top:7,
            width:14,
            height:14
          }
        },
        {
          ele: '',
          img: getImage('lessons2.png'),
          imgStyle: {
            top:`0px`,
            left:'-500px',
            width:'647px',
            height:'223px'
          },
          btnsStyle: {
            bottom: '30px',
            left: px2vw(-90),
          },

          eleRectPadding:{
            left:7,
            top:7,
            width:14,
            height:14
          },
          type:'left'

        },
        {
          ele: '',
          img: getImage('lessons3.png'),
          imgStyle: {
            top: '100%',
            left:  '-265px',
            width: '515px',
            height:'227px'
          },
          btnsStyle: {
            bottom: '30px',
            left: px2vw(-90),
          },

          eleRectPadding:{
            left:7,
            top:7,
            width:14,
            height:14
          },
          type:'left'

        },
        {
          ele: '',
          img: getImage('lessons4.png'),
          imgStyle: {
            top: '100%',
            left:  '-265px',
            width: '515px',
            height:'227px'
          },
          btnsStyle: {
            bottom: '30px',
            left: px2vw(-90),
          },

          eleRectPadding:{
            left:7,
            top:7,
            width:14,
            height:14
          }

        },
        {
          ele: '',
          img: getImage('lessons5.png'),
          imgStyle: {
            top: '100%',
            left:  '-290px',
            width: '648px',
            height:'228px'
          },
          btnsStyle: {
            bottom: '30px',
            left: px2vw(-90),
          },

          eleRectPadding:{
            left:7,
            top:7,
            width:14,
            height:14
          }

        },
      ],
      step: 0
    });
    const tipShow = ref(false);
    const guideInfo = localStorage.getItem('teacher-guideInfo');
    if (guideInfo && JSON.parse(guideInfo).lessonsGuide) {
      tipShow.value = false;
    } else {
      tipShow.value = true;
    }
    const getStepELe = () => {

      const ele: HTMLElement = document.getElementById(`lessons-${data.step}`)!;

      if (ele) {
        const eleRect = ele.getBoundingClientRect();

        const left = data.steps[data.step].eleRectPadding?.left || 0;
        const top = data.steps[data.step].eleRectPadding?.top || 0;
        const width = data.steps[data.step].eleRectPadding?.width || 0;
        const height = data.steps[data.step].eleRectPadding?.height || 0
        data.box = {
          left: eleRect.x - left+ 'px',
          top: eleRect.y - top +'px',
          width: eleRect.width + width+'px',
          height: eleRect.height +height+ 'px'
        };
        console.log(`coai-${data.step}`,data.box);
      }
    };
    onMounted(() => {
      getStepELe();
    });

    const handleNext = () => {
      if (data.step >= 4) {
        endGuide();
        return;
      }
      data.step = data.step + 1;
      getStepELe();
    };

    const endGuide = () => {
      let guideInfo =
        JSON.parse(localStorage.getItem('teacher-guideInfo')) || null;
      if (!guideInfo) {
        guideInfo = { lessonsGuide: true };
      } else {
        guideInfo.lessonsGuide = true;
      }
      localStorage.setItem('teacher-guideInfo', JSON.stringify(guideInfo));
      tipShow.value = false;
      //  localStorage.setItem('endC')
    };
    return () => (
      <>
        {tipShow.value ? (
          <div
            v-model:show={tipShow.value}
            class={['n-modal-mask', 'n-modal-mask-guide']}>
            <div class={styles.content} onClick={() => handleNext()}>
              <div
                class={styles.backBtn}
                onClick={(e: Event) => {
                  e.stopPropagation();
                  endGuide();
                }}>
                跳过
              </div>
              <div
                class={styles.box}
                style={{...data.box,...data.steps[data.step].boxStyle}}
                id={`modeType-${data.step}`}>

                {data.steps.map((item: any, index) => (

                  <div
                    onClick={(e: Event) => e.stopPropagation()}
                    class={styles.item}
                    style={ item.type=='bottom'?  {
                      display: index === data.step ? '' : 'none',
                      left: `${item.eleRect?.left}px`,
                      top:`-${item.imgStyle?.height}`
                    }: item.type=='left'?{
                      display: index === data.step ? '' : 'none',
                      left: `${ parseFloat(data.box?.width)/2-parseFloat(item.imgStyle?.width)/2-14}px`,
                     top: `${ parseFloat(data.box?.height)/2-parseFloat(item.imgStyle?.height)/20+14}px`,
                    }:{
                      display: index === data.step ? '' : 'none',
                      left: `${item.eleRect?.left}px`,
                     top: `${data.box?.height}`,

                    }}>

                    <img
                      class={styles.img}
                      style={item.imgStyle}
                      src={item.img}
                    />
                    {/* <img
                      class={styles.iconHead}
                      style={item.handStyle}
                      src={getImage('indexDot.png')}
                    /> */}
                    <div class={styles.btns} style={item.btnsStyle}>
                      {data.step + 1 == data.steps.length ? (
                        <>
                         <div
                            class={[styles.endBtn]}
                            onClick={() => endGuide()}>
                            完成
                          </div>
                          <div
                            class={styles.nextBtn}
                            onClick={() => {
                              data.step = 0;
                              getStepELe();
                            }}>
                            再看一遍
                          </div>

                        </>
                      ) : (
                        <div class={styles.btn} onClick={() => handleNext()}>
                          下一步 ({data.step + 1}/{data.steps.length})
                        </div>
                      )}
                    </div>
                  </div>
                ))}
              </div>
            </div>
          </div>
        ) : null}
      </>
    );
  }
});
